(function() {
  var Help, i, leftCol, rank, specification, t, type, _len, _ref;
  var __hasProp = Object.prototype.hasOwnProperty;
  specification = require('./specification');
  type = require('./types');
  leftCol = function(spec, alias, long) {
    var prefix, str;
    prefix = long ? '--' : '-';
    str = prefix + alias;
    if (spec.type !== type.flag) {
      if (spec.type === type.object) {
        str += ' KEY=VAL';
      } else if (long) {
        str += '=VAL';
      } else {
        str += ' VAL';
      }
    }
    return str;
  };
  rank = {};
  _ref = ['flag', 'scalar', 'array', 'object'];
  for (i = 0, _len = _ref.length; i < _len; i++) {
    t = _ref[i];
    rank[type[t]] = i;
  }
  exports.Help = Help = (function() {
    Help.prototype.tw = 78;
    function Help(spec) {
      this.spec = spec;
      specification.index(this.spec);
    }
    Help.prototype.toString = function() {
      var all, cur, desc, i, l, left, lengths, line, lines, max, pad, remaining, right, s, sep, sub, target, w, words, _i, _j, _k, _l, _len2, _len3, _len4, _len5, _ref2, _ref3, _ref4, _ref5;
      lines = [];
      _ref2 = this.spec;
      for (target in _ref2) {
        if (!__hasProp.call(_ref2, target)) continue;
        sub = _ref2[target];
        line = {
          rank: rank[sub.type]
        };
        left = (function() {
          var _i, _len2, _ref3, _results;
          _ref3 = sub.short.slice(0).sort();
          _results = [];
          for (_i = 0, _len2 = _ref3.length; _i < _len2; _i++) {
            s = _ref3[_i];
            _results.push(leftCol(sub, s, false));
          }
          return _results;
        })();
        _ref3 = sub.long.slice(0).sort();
        for (_i = 0, _len2 = _ref3.length; _i < _len2; _i++) {
          s = _ref3[_i];
          left.push(leftCol(sub, s, true));
        }
        line.left = left;
        line.first = left[0];
        line.last = left[left.length - 1];
        right = [];
        if (desc = sub.description.trim().replace(/\.$/, '')) {
          right.push(desc);
        }
        if (sub.required) {
          right.push('Required');
        }
        if (sub.type === type.array || sub.type === type.object) {
          right.push('Can be specified multiple times');
        }
        if (sub["default"]) {
          right.push('Default: ' + JSON.stringify(sub["default"]));
        }
        line.right = right.join('. ');
        if (right.length) {
          line.right += '.';
        }
        lines.push(line);
      }
      lengths = (function() {
        var _j, _len3, _results;
        _results = [];
        for (_j = 0, _len3 = lines.length; _j < _len3; _j++) {
          l = lines[_j];
          _results.push(l.last.length);
        }
        return _results;
      })();
      max = Math.max.apply(Math, lengths);
      for (_j = 0, _len3 = lines.length; _j < _len3; _j++) {
        line = lines[_j];
        _ref4 = line.left;
        for (i = 0, _len4 = _ref4.length; i < _len4; i++) {
          l = _ref4[i];
          pad = max - l.length;
          if (pad) {
            for (_k = 1; 1 <= pad ? _k <= pad : _k >= pad; 1 <= pad ? _k++ : _k--) {
              l = ' ' + l;
            }
          }
          line.left[i] = l;
        }
        line.left[line.left.length - 1] += '  ';
      }
      remaining = this.tw - max - 2;
      sep = "\n";
      for (_l = 1, _ref5 = max + 2; 1 <= _ref5 ? _l <= _ref5 : _l >= _ref5; 1 <= _ref5 ? _l++ : _l--) {
        sep += ' ';
      }
      for (i = 0, _len5 = lines.length; i < _len5; i++) {
        l = lines[i];
        words = (function() {
          var _len6, _m, _ref6, _results;
          _ref6 = l.right.split(/\s/);
          _results = [];
          for (_m = 0, _len6 = _ref6.length; _m < _len6; _m++) {
            w = _ref6[_m];
            _results.push(w.trim());
          }
          return _results;
        })();
        words = ((function() {
          var _len6, _m, _results;
          if (w.length > 0) {
            _results = [];
            for (_m = 0, _len6 = words.length; _m < _len6; _m++) {
              w = words[_m];
              _results.push(w);
            }
            return _results;
          }
        })());
        all = '';
        cur = words.shift();
        while (words.length > 0) {
          w = words.shift();
          if (w.length + cur.length < remaining) {
            cur += ' ' + w;
          } else {
            all += cur + sep;
            cur = w;
          }
        }
        lines[i].right = all + cur;
      }
      lines.sort(function(a, b) {
        return (a.rank - b.rank) || a.first.localeCompare(b.first);
      });
      return ((function() {
        var _len6, _m, _results;
        _results = [];
        for (_m = 0, _len6 = lines.length; _m < _len6; _m++) {
          l = lines[_m];
          _results.push(l.left.join("\n") + l.right);
        }
        return _results;
      })()).join("\n\n");
    };
    return Help;
  })();
}).call(this);
