(function() {
  var BaseError, Conflict, FlagWithValue, InternalError, InvalidShort, NoType, NoValue, ParseError, RequiredMissing, ScalarWithValues, SpecError, UnknownOption, UnknownType, UnvalidatedType;
  var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  exports.BaseError = BaseError = (function() {
    function BaseError(desc) {
      this.desc = desc;
      Error.captureStackTrace(this, this.constructor);
      this.message = this.describe();
    }
    __extends(BaseError, Error);
    BaseError.prototype.toString = function() {
      return 'yanop.' + this.constructor.name + ': ' + this.describe();
    };
    BaseError.prototype.describe = function() {
      return JSON.stringify(this.desc);
    };
    return BaseError;
  })();
  exports.InternalError = InternalError = (function() {
    function InternalError() {
      InternalError.__super__.constructor.apply(this, arguments);
    }
    __extends(InternalError, BaseError);
    return InternalError;
  })();
  exports.UnvalidatedType = UnvalidatedType = (function() {
    function UnvalidatedType() {
      UnvalidatedType.__super__.constructor.apply(this, arguments);
    }
    __extends(UnvalidatedType, InternalError);
    return UnvalidatedType;
  })();
  exports.SpecError = SpecError = (function() {
    function SpecError() {
      SpecError.__super__.constructor.apply(this, arguments);
    }
    __extends(SpecError, BaseError);
    return SpecError;
  })();
  exports.InvalidShort = InvalidShort = (function() {
    function InvalidShort() {
      InvalidShort.__super__.constructor.apply(this, arguments);
    }
    __extends(InvalidShort, SpecError);
    return InvalidShort;
  })();
  exports.Conflict = Conflict = (function() {
    function Conflict() {
      Conflict.__super__.constructor.apply(this, arguments);
    }
    __extends(Conflict, SpecError);
    return Conflict;
  })();
  exports.NoType = NoType = (function() {
    function NoType() {
      NoType.__super__.constructor.apply(this, arguments);
    }
    __extends(NoType, SpecError);
    return NoType;
  })();
  exports.UnknownType = UnknownType = (function() {
    function UnknownType() {
      UnknownType.__super__.constructor.apply(this, arguments);
    }
    __extends(UnknownType, SpecError);
    return UnknownType;
  })();
  exports.ParseError = ParseError = (function() {
    function ParseError() {
      ParseError.__super__.constructor.apply(this, arguments);
    }
    __extends(ParseError, BaseError);
    return ParseError;
  })();
  exports.UnknownOption = UnknownOption = (function() {
    function UnknownOption() {
      UnknownOption.__super__.constructor.apply(this, arguments);
    }
    __extends(UnknownOption, ParseError);
    UnknownOption.prototype.describe = function() {
      return "Unknown option " + this.desc + " encountered";
    };
    return UnknownOption;
  })();
  exports.NoValue = NoValue = (function() {
    function NoValue() {
      NoValue.__super__.constructor.apply(this, arguments);
    }
    __extends(NoValue, ParseError);
    NoValue.prototype.describe = function() {
      return this.desc + " requires a value, but none was given";
    };
    return NoValue;
  })();
  exports.FlagWithValue = FlagWithValue = (function() {
    function FlagWithValue() {
      FlagWithValue.__super__.constructor.apply(this, arguments);
    }
    __extends(FlagWithValue, ParseError);
    FlagWithValue.prototype.describe = function() {
      return "" + this.desc.name + " was given \"" + this.desc.value + "\", but takes no arguments";
    };
    return FlagWithValue;
  })();
  exports.ScalarWithValues = ScalarWithValues = (function() {
    function ScalarWithValues() {
      ScalarWithValues.__super__.constructor.apply(this, arguments);
    }
    __extends(ScalarWithValues, ParseError);
    ScalarWithValues.prototype.describe = function() {
      return this.desc + " was given more than one value";
    };
    return ScalarWithValues;
  })();
  exports.RequiredMissing = RequiredMissing = (function() {
    function RequiredMissing() {
      RequiredMissing.__super__.constructor.apply(this, arguments);
    }
    __extends(RequiredMissing, ParseError);
    RequiredMissing.prototype.describe = function() {
      return "Required option " + this.desc + " was missing";
    };
    return RequiredMissing;
  })();
}).call(this);
