(function() {
  var ex, type;
  var __hasProp = Object.prototype.hasOwnProperty;
  ex = require('./exceptions');
  type = require('./types');
  exports.index = function(spec) {
    var a, alias, existing, index, l, longs, s, shorts, sub, t, target, _i, _j, _len, _len2;
    index = {};
    for (target in spec) {
      if (!__hasProp.call(spec, target)) continue;
      sub = spec[target];
      longs = sub.long || [target];
      if (!Array.isArray(longs)) {
        longs = [longs];
      }
      sub.long = longs;
      shorts = sub.short || [];
      if (!Array.isArray(shorts)) {
        shorts = [shorts];
      }
      sub.short = shorts;
      alias = (function() {
        var _i, _len, _results;
        _results = [];
        for (_i = 0, _len = longs.length; _i < _len; _i++) {
          l = longs[_i];
          _results.push('--' + l);
        }
        return _results;
      })();
      for (_i = 0, _len = shorts.length; _i < _len; _i++) {
        s = shorts[_i];
        if (s.length !== 1) {
          throw new ex.InvalidShort(s);
        }
        alias.push('-' + s);
      }
      for (_j = 0, _len2 = alias.length; _j < _len2; _j++) {
        a = alias[_j];
        existing = index[a];
        if (existing) {
          throw new ex.Conflict(target, a, existing);
        }
        index[a] = target;
      }
      t = sub.type;
      if (!t) {
        throw new ex.NoType(target);
      }
      if (t === type.array) {
        sub["default"] || (sub["default"] = []);
      } else if (t === type.object) {
        sub["default"] || (sub["default"] = {});
      } else if (t !== type.scalar && t !== type.flag) {
        throw new ex.UnknownType({
          name: target,
          type: t
        });
      }
    }
    return index;
  };
}).call(this);
