(function() {
  var file, getargs, m, path, reexport, _i, _len, _ref;
  var __hasProp = Object.prototype.hasOwnProperty;
  file = require('file');
  path = require('path');
  reexport = function(module) {
    var key, m, val, _results;
    m = require(module);
    _results = [];
    for (key in m) {
      if (!__hasProp.call(m, key)) continue;
      val = m[key];
      _results.push(exports[key] = val);
    }
    return _results;
  };
  _ref = ['./types', './exceptions', './Parser', './Help'];
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    m = _ref[_i];
    reexport(m);
  }
  getargs = function(argv) {
    return argv || process.argv.slice(2);
  };
  exports.parse = function(spec, argv) {
    return new exports.Parser(spec).parse(getargs(argv));
  };
  exports.zero = function() {
    var abs, rel, script;
    abs = path.normalize(process.argv[1]);
    rel = file.path.relativePath(process.cwd(), abs);
    script = rel.length < abs.length ? rel : abs;
    return "" + process.argv[0] + " " + script;
  };
  exports.usage = function() {
    return "\nUsage: " + (exports.zero()) + " [OPTIONS]\n";
  };
  exports.help = function(spec) {
    return new exports.Help(spec).toString();
  };
  exports.tryParse = function(spec, argv) {
    var o, p;
    p = new exports.Parser(spec);
    try {
      o = p.parse(getargs(argv));
    } catch (e) {
      if (!(e instanceof exports.ParseError)) {
        throw e;
      }
      process.stderr.write(e.message + "\n");
      process.exit(1);
    }
    return o;
  };
  exports.simple = exports.tryParseWithHelp = function(spec, banner, argv) {
    var flag, h, o, p;
    spec.help || (spec.help = {
      type: exports.flag,
      short: 'h',
      description: 'Print this message and exit'
    });
    p = new exports.Parser(spec);
    try {
      argv = getargs(argv);
      o = p.parse(getargs(argv));
      if (o.help) {
        h = exports.help(spec);
        banner || (banner = exports.usage());
        process.stdout.write([banner, "The following options are recognized:\n", h].join("\n") + "\n\n");
        process.exit(0);
      }
    } catch (e) {
      if (!(e instanceof exports.ParseError)) {
        throw e;
      }
      h = spec.help;
      flag = h.long ? "--" + h.long : "-" + h.short;
      process.stderr.write(e.message + (". Pass " + flag + " for usage information.\n"));
      process.exit(1);
    }
    return o;
  };
}).call(this);
