(function() {
  var expected, yanop;
  yanop = require('../lib/yanop');
  expected = '              -v\n       --verbose  Print debugging messages.\n\n  --password=VAL  Secret string to use when connecting to server. This\n                  description is going to be ridiculously long so that we can\n                  test the line breaking a bit. Required.\n\n          -o VAL\n    --output=VAL  Filename (- for stdout) to write output to. Default: "-".\n\n          -i VAL\n     --input=VAL  Filename(s) (- for stdin) to read input from. Can be\n                  specified multiple times. Default: ["-"].\n\n      -D KEY=VAL\n--define KEY=VAL  Symbols to define during processing. Can be specified\n                  multiple times. Default: {}.';
  exports.basic = function(t) {
    var spec, u;
    t.expect(1);
    spec = {
      verbose: {
        type: yanop.flag,
        short: 'v',
        description: 'Print debugging messages'
      },
      output: {
        type: yanop.scalar,
        short: 'o',
        description: 'Filename (- for stdout) to write output to.',
        "default": '-'
      },
      input: {
        type: yanop.list,
        short: 'i',
        description: 'Filename(s) (- for stdin) to read input from',
        "default": ['-']
      },
      password: {
        type: yanop.scalar,
        description: 'Secret string to use when connecting to server. This description is going to be ridiculously long so that we can test the line breaking a bit',
        required: true
      },
      symbols: {
        type: yanop.hash,
        short: 'D',
        long: 'define',
        description: 'Symbols to define during processing'
      }
    };
    u = new yanop.Help(spec);
    t.equals(u.toString(), expected);
    return t.done();
  };
}).call(this);
