(function() {
  var ex, spec, type;
  spec = require('../lib/specification');
  ex = require('../lib/exceptions');
  type = require('../lib/types');
  exports.type = function(t) {
    t.expect(2);
    t.throws((function() {
      return spec.index({
        foo: {
          short: 'f'
        }
      });
    }), ex.NoType);
    t.throws((function() {
      return spec.index({
        foo: {
          type: 'none'
        }
      });
    }), ex.UnknownType);
    return t.done();
  };
  exports.short = function(t) {
    var short;
    t.expect(4);
    short = function(err, val) {
      var cons, tfn;
      cons = function() {
        return spec.index({
          foo: {
            type: type.flag,
            short: val
          }
        });
      };
      tfn = err ? t.throws : t.doesNotThrow;
      return tfn.call(t, cons, ex.InvalidShort);
    };
    short(true, 'foo');
    short(true, 'ab');
    short(false, 'a');
    short(false, 'b');
    return t.done();
  };
  exports.conflicts = function(t) {
    var conflict;
    t.expect(6);
    conflict = function(err, fn) {
      var cons, s, tfn;
      s = {
        foo: {
          type: type.flag
        },
        bar: {
          type: type.flag
        }
      };
      fn(s);
      tfn = err ? t.throws : t.doesNotThrow;
      cons = function() {
        return spec.index(s);
      };
      return tfn.call(t, cons, ex.Conflict);
    };
    conflict(true, function(s) {
      return s.bar.long = 'foo';
    });
    conflict(true, function(s) {
      return s.foo.long = ['foo', 'bar', 'baz'];
    });
    conflict(true, function(s) {
      s.foo.long = 'different';
      return s.bar.long = 'different';
    });
    conflict(true, function(s) {
      s.foo.short = 's';
      return s.bar.short = ['q', 'r', 's'];
    });
    conflict(false, function(s) {
      s.foo.long = 's';
      return s.bar.short = 's';
    });
    conflict(false, function(s) {
      s.foo.short = 'a';
      return s.bar.long = ['a', 'abstruse'];
    });
    return t.done();
  };
}).call(this);
